## sight 21.1.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)

# Use new policy for 'install_name' and RPATH on macOS (use `cmake --help-policy CMP0068` for details)
cmake_policy(SET CMP0068 NEW)
# Use new policy for `FindOpenGL` to prefer GLVND by default when available on linux.
# (use `cmake --help-policy CMP0072` for details).
cmake_policy(SET CMP0072 NEW)
# Use new policy for 'Honor visibility properties for all target types'.
# (use `cmake --help-policy CMP0063` for details)
cmake_policy(SET CMP0063 NEW)
# Adds support for the new IN_LIST operator.
cmake_policy(SET CMP0057 NEW)
# Use new policy to use CMAKE_CXX_STANDARD in try_compile() macro
cmake_policy(SET CMP0067 NEW)
# Use old policy for Documentation to add cache variables and find VTK documentation dependent packages.
# (Needed for doxygen..)
cmake_policy(SET CMP0106 OLD)

if(${CMAKE_VERSION} VERSION_GREATER "3.20.0")
    # Transform the ``DEPFILE`` after running the custom command for Ninja generator.
    cmake_policy(SET CMP0116 OLD)
endif()

# On Windows, if the user doesn't specify a value,
# 'CMAKE_BUILD_TYPE' is automatically initialized to 'Debug' after 'project()'.
# So we need to check this variable at this point.
set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING
                                               "Choose the type of build, options are: Debug, Release, RelWithDebInfo"
)
set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug;Release;RelWithDebInfo")

if(NOT CMAKE_BUILD_TYPE STREQUAL "Debug" AND NOT CMAKE_BUILD_TYPE STREQUAL "Release" AND NOT CMAKE_BUILD_TYPE STREQUAL
                                                                                         "RelWithDebInfo"
)
    message(
        FATAL_ERROR
            "Invalid value for CMAKE_BUILD_TYPE: '${CMAKE_BUILD_TYPE}' (required Debug, Release, RelWithDebInfo)"
    )
endif()

project(
    sight
    VERSION 21.1.0
    DESCRIPTION "Surgical Image Guidance and Healthcare Toolkit"
    HOMEPAGE_URL "https://git.ircad.fr/sight/sight"
)

if(APPLE)
    message(FATAL_ERROR "macOS is not supported.")
endif()

enable_testing()

include(CheckVariableExists)
include(CMakeParseArguments)
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

option(SIGHT_ENABLE_PCH "Use pre-compiled headers to speedup the compilation" ON)
option(SIGHT_VERBOSE_PCH "Display debug messages to help debugging PCH" OFF)
mark_as_advanced(SIGHT_ENABLE_PCH)
mark_as_advanced(SIGHT_VERBOSE_PCH)

include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/build/flags.cmake)
include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/build/macros.cmake)
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/build/linux/modules)

# We find VTK to know its version so we can enable PCL or not
find_package(VTK CONFIG QUIET REQUIRED)

########################################################################################################################
# User options
########################################################################################################################

# Tests build / run options
option(SIGHT_BUILD_TESTS "Configures projects associated tests (<project>Test projects)" ON)

option(SIGHT_TESTS_XML_OUTPUT "Tests will generate an xml output, suitable for CI integration" ON)
mark_as_advanced(SIGHT_TESTS_XML_OUTPUT)

set(SIGHT_TESTS_FILTER "" CACHE STRING "Allows to only build/run tests whose path contains the filter string.")
mark_as_advanced(SIGHT_TESTS_FILTER)

if(UNIX AND (${CMAKE_BUILD_TYPE} STREQUAL "Debug" OR ${CMAKE_BUILD_TYPE} STREQUAL "RelWithDebInfo"))
    option(SIGHT_ENABLE_GDB
           "Test scripts will attach GDB, allowing to generate core file and print backtrace in case of crash." OFF
    )
    mark_as_advanced(SIGHT_ENABLE_GDB)

    if(SIGHT_ENABLE_GDB)
        find_program(GDB NAMES "gdb" REQUIRED)
    endif()
endif()

# Use clang-tidy linter
option(SIGHT_ENABLE_CLANG_TIDY "Enable Clang Tidy checks" OFF)
mark_as_advanced(SIGHT_TESTS_FILTER)

if(SIGHT_ENABLE_CLANG_TIDY)
    # cmake-lint: disable=C0301
    find_program(CLANG_TIDY NAMES "clang-tidy" "clang-tidy-10" "clang-tidy-11" "clang-tidy-12" "clang-tidy-13" REQUIRED)
    set(CMAKE_CXX_CLANG_TIDY
        ${CLANG_TIDY};--header-filter=.*;--checks=*,-llvm-header-guard,-llvm-include-order,-llvmlibc-*,-fuchsia-*,-altera-struct-pack-align,-cppcoreguidelines-macro-usage,-bugprone-macro-parentheses;--use-color;--export-fixes=.clang-tidy-fixes.yaml
    )
endif()

# QML_IMPORT_PATH allows qtCreator to find the qml modules created in our modules
set(QML_IMPORT_PATH "" CACHE STRING "Path of the Qml modules." FORCE)
mark_as_advanced(QML_IMPORT_PATH)

include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/build/PrecompiledHeader.cmake)

if(MSVC)
    if(NOT DEFINED CMAKE_PCH_COMPILER_TARGETS)
        # this will be executed in just before makefile generation
        variable_watch(CMAKE_BACKWARDS_COMPATIBILITY pch_msvc_hook)
    endif()
endif()

if(CMAKE_CONFIGURATION_TYPES)
    set(CMAKE_CONFIGURATION_TYPES ${CMAKE_BUILD_TYPE} CACHE STRING "List of supported configurations." FORCE)
endif()

# Allow to use an encrypted log
option(SIGHT_ENABLE_ENCRYPTED_LOG "Allow log encryption" OFF)

# Defines the default hardcoded password. The password itself will be obfuscated during build process, it will not
# appear in "clear" text in the final binary.
set(SIGHT_DEFAULT_PASSWORD "" CACHE STRING "Default password to use for encryption (log, preferences, session, ...).")
mark_as_advanced(SIGHT_DEFAULT_PASSWORD)

# Add global compile definitions because of precompiled headers
if(SIGHT_ENABLE_ENCRYPTED_LOG)
    add_compile_definitions(SIGHT_ENABLE_ENCRYPTED_LOG)
endif()
add_compile_definitions(SIGHT_DEFAULT_PASSWORD="${SIGHT_DEFAULT_PASSWORD}")

# Use solution folders.
set_property(GLOBAL PROPERTY USE_FOLDERS ON)
set_property(GLOBAL PROPERTY AUTOGEN_TARGETS_FOLDER automoc)

# Make openvslam optional
option(SIGHT_ENABLE_OPENVSLAM "Enable OpenVSLAM" OFF)

# Make Realsense optional
option(SIGHT_ENABLE_REALSENSE "Enable RealSense" OFF)

# Make samples/tutorials build optional
option(SIGHT_BUILD_EXAMPLES "Build examples and tutorials" ON)

########################################################################################################################
# Warn user of install dir isn't empty
########################################################################################################################

file(GLOB_RECURSE INSTALL_DIR_CONTENT ${CMAKE_INSTALL_PREFIX}/*)
list(LENGTH INSTALL_DIR_CONTENT CONTENT)
if(NOT CONTENT EQUAL 0)
    # DIR isn't empty, warn user.
    message(WARNING "CMAKE_INSTALL_PREFIX (${CMAKE_INSTALL_PREFIX}) isn't empty."
                    "Please select another folder or clean it before running install command."
    )
endif()

########################################################################################################################
# External libraries management
########################################################################################################################

set(FWCMAKE_RESOURCE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/)

# Append our 'FindPackages.cmake' to CMAKE_MODULE_PATH
list(APPEND CMAKE_MODULE_PATH ${FWCMAKE_RESOURCE_PATH}/modules)

if(UNIX)
    list(APPEND CMAKE_PREFIX_PATH ${FWCMAKE_RESOURCE_PATH}/modules)

    list(APPEND CMAKE_FIND_ROOT_PATH ${FWCMAKE_RESOURCE_PATH}/modules)
    if(UNIX)
        list(APPEND CMAKE_PREFIX_PATH /usr/share/OGRE/cmake/modules)
    endif()

    set(SIGHT_EXTERNAL_LIBRARIES CACHE PATH "External libraries location")
    mark_as_advanced(SIGHT_EXTERNAL_LIBRARIES)

    # Use directly SIGHT_EXTERNAL_LIBRARIES if set, otherwise, download and install sight-deps package
    # OpenVSLAM is the only package provided by sight-deps
    if(NOT SIGHT_EXTERNAL_LIBRARIES AND SIGHT_ENABLE_OPENVSLAM)
        include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/build/download_deps.cmake)
    endif()

    if(SIGHT_EXTERNAL_LIBRARIES)
        get_filename_component(ABSOLUTE_SIGHT_EXTERNAL_LIBRARIES ${SIGHT_EXTERNAL_LIBRARIES} REALPATH)
        set(SIGHT_EXTERNAL_LIBRARIES ${ABSOLUTE_SIGHT_EXTERNAL_LIBRARIES})
        unset(ABSOLUTE_SIGHT_EXTERNAL_LIBRARIES)

        list(APPEND CMAKE_PREFIX_PATH ${SIGHT_EXTERNAL_LIBRARIES})
        list(APPEND CMAKE_MODULE_PATH ${SIGHT_EXTERNAL_LIBRARIES}/lib/cmake/)
        list(APPEND CMAKE_FIND_ROOT_PATH ${SIGHT_EXTERNAL_LIBRARIES})
        # To be added into LD_LIBRARY_PATH in our "launch" scripts.
        set(SIGHT_EXTERNAL_LIBRARIES_LIB_PATH ${SIGHT_EXTERNAL_LIBRARIES}/lib/)
    endif()
endif()

# We always need CppUnit, no need to put that in subdirectories
find_package(CppUnit QUIET REQUIRED)

########################################################################################################################
# Default paths settings for libraries, modules and resources
########################################################################################################################

set(FW_INSTALL_PATH_SUFFIX "${PROJECT_NAME}")
set(SIGHT_MODULE_RC_PREFIX "${CMAKE_INSTALL_DATADIR}/${FW_INSTALL_PATH_SUFFIX}")
if(WIN32)
    set(SIGHT_MODULE_LIB_PREFIX "${CMAKE_INSTALL_BINDIR}")
else()
    set(SIGHT_MODULE_LIB_PREFIX "${CMAKE_INSTALL_LIBDIR}")
endif()

set(FWCONFIG_PACKAGE_LOCATION lib/cmake/sight)
set_property(GLOBAL PROPERTY ${PROJECT_NAME}_COMPONENTS "")

# Define the path 'FW_SIGHT_EXTERNAL_LIBRARIES_DIR' used to find external libraries required by our applications
set_external_libraries_dir()
if("${CMAKE_BUILD_TYPE}" STREQUAL "Debug")
    set(SIGHT_VCPKG_ROOT_DIR "${_VCPKG_INSTALLED_DIR}/${VCPKG_TARGET_TRIPLET}/debug")
else()
    set(SIGHT_VCPKG_ROOT_DIR "${_VCPKG_INSTALLED_DIR}/${VCPKG_TARGET_TRIPLET}")
    set(EXCLUDE_PATTERN ".*/debug/.*")
endif()

add_subdirectory(libs)
add_subdirectory(modules)
add_subdirectory(configs)
add_subdirectory(activities)
add_subdirectory(utils)
add_subdirectory(apps)
if(SIGHT_BUILD_EXAMPLES)
    add_subdirectory(tutorials)
    add_subdirectory(examples)
endif()

########################################################################################################################
# Export and install targets
########################################################################################################################

# Will export COMPONENTS: list of all available components ordered by dependency (no dependency first).
sight_generate_component_list(COMPONENTS)

# Create the sightConfigVersion file
configure_file(${CMAKE_SOURCE_DIR}/cmake/build/sightConfig.cmake.in ${CMAKE_BINARY_DIR}/cmake/sightConfig.cmake @ONLY)

write_basic_package_version_file(
    "${CMAKE_BINARY_DIR}/cmake/sightConfigVersion.cmake" VERSION ${PROJECT_VERSION} COMPATIBILITY AnyNewerVersion
)

# Install a special xvfb-run wrapper script to workaround bugs withe the system xvfb-run launcher script
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/cmake/install/linux/safe-xvfb-run ${CMAKE_CURRENT_BINARY_DIR}/bin/safe-xvfb-run
    COPYONLY
)

# Install the sightConfig.cmake and sightConfigVersion.cmake
install(
    FILES "${CMAKE_BINARY_DIR}/cmake/sightConfig.cmake" "${CMAKE_BINARY_DIR}/cmake/sightConfigVersion.cmake"
          "${CMAKE_SOURCE_DIR}/cmake/build/macros.cmake"
          "${CMAKE_SOURCE_DIR}/cmake/build/linux/modules/FindFilesystem.cmake"
    DESTINATION ${FWCONFIG_PACKAGE_LOCATION}
    COMPONENT dev
)

# install CppUnitConfig.cmake in a modules folder.
install(FILES "${CMAKE_SOURCE_DIR}/cmake/modules/CppUnitConfig.cmake" DESTINATION ${FWCONFIG_PACKAGE_LOCATION}/modules
        COMPONENT dev
)

# Install some files needed for the build
install(
    FILES "${CMAKE_SOURCE_DIR}/cmake/build/configure_file.cmake"
          "${CMAKE_SOURCE_DIR}/cmake/build/flags.cmake"
          "${FWCMAKE_RESOURCE_PATH}/build/cppunit_main.cpp"
          "${CMAKE_SOURCE_DIR}/cmake/build/config.hpp.in"
          "${CMAKE_SOURCE_DIR}/cmake/build/plugin_config.cmake"
          "${CMAKE_SOURCE_DIR}/cmake/build/plugin_config_command.cmake"
          "${CMAKE_SOURCE_DIR}/cmake/build/profile_config.cmake"

=== examples/CMakeLists.txt ===
add_subdirectory(core)
add_subdirectory(ui)
add_subdirectory(io)
add_subdirectory(filter)
add_subdirectory(geometry)
add_subdirectory(navigation)

=== libs/CMakeLists.txt ===
add_subdirectory(core)
add_subdirectory(geometry)
add_subdirectory(io/base)
add_subdirectory(io/itk)
add_subdirectory(filter)
add_subdirectory(ui)
add_subdirectory(io)
add_subdirectory(navigation)
add_subdirectory(viz)

=== modules/CMakeLists.txt ===
add_subdirectory(core)
add_subdirectory(filter)
add_subdirectory(geometry)
add_subdirectory(io)
add_subdirectory(navigation)
add_subdirectory(ui)
add_subdirectory(viz)

=== tutorials/CMakeLists.txt ===
add_subdirectory(xml)
add_subdirectory(cpp)
add_subdirectory(qml)

=== utils/CMakeLists.txt ===
add_subdirectory(DicomAnonymizer)
add_subdirectory(sightrun)
add_subdirectory(arucoMarker)
add_subdirectory(charucoBoard)
add_subdirectory(NetworkProxy)
add_subdirectory(calDataGenerator)
add_subdirectory(sightlog)

=== activities/io/CMakeLists.txt ===
add_subdirectory(dicom)
add_subdirectory(dicomweb)
add_subdirectory(ioActivity)

=== apps/SightCalibrator/CMakeLists.txt ===
sight_add_target(SightCalibrator TYPE APP)

add_dependencies(
    SightCalibrator
    sightrun
    module_appXml
    module_ui_base
    module_ui_qt
    module_service
    module_sync
    data
    module_ui_base
    module_ui_flaticons
    module_ui_icons
    module_io_vision
    module_io_video
    module_io_activity
    module_io_igtl
    module_io_session
    module_activity
    activity_navigation_calibration
    module_data
    module_memory
    module_geometry_vision
    module_geometry_base
    module_navigation_calibration
)

if(SIGHT_ENABLE_REALSENSE)
    add_dependencies(SightCalibrator module_io_realsense)
endif()

# Allow dark theme via module_ui_qt
module_param(
    module_ui_qt PARAM_LIST resource stylesheet PARAM_VALUES sight::module::ui::qt/flatdark.rcc
                                                             sight::module::ui::qt/flatdark.qss
)
# Main application's configuration to launch
module_param(module_appXml PARAM_LIST config parameters PARAM_VALUES SightCalibrator_AppCfg SightCalibrator_AppCfgParam)

sight_generate_profile(SightCalibrator)

=== apps/SightViewer/CMakeLists.txt ===
sight_add_target(SightViewer TYPE APP)

add_dependencies(
    SightViewer
    sightrun
    module_appXml
    module_ui_base
    module_viz_scene3d
    module_ui_qt
    module_viz_scene3dQt
    module_service
    data
    viz_scene2d
    module_ui_base
    module_ui_viz
    module_ui_flaticons
    module_io_vtk
    module_io_dicom
    module_io_session
    module_viz_scene2d
    module_data
    module_filter_image
    config_viz_scene3d
    config_io_dimse
)

# Allow dark theme via module_ui_qt
module_param(
    module_ui_qt PARAM_LIST resource stylesheet PARAM_VALUES sight::module::ui::qt/flatdark.rcc
                                                             sight::module::ui::qt/flatdark.qss
)

# Main application's configuration to launch
module_param(module_appXml PARAM_LIST config PARAM_VALUES SightViewer_AppCfg)

sight_generate_profile(SightViewer)

=== apps/dicomxplorer/CMakeLists.txt ===
sight_add_target(dicomxplorer TYPE APP)

add_dependencies(
    dicomxplorer
    module_service
    data
    module_ui_base
    module_ui_qt
    module_activity
    module_appXml
    module_memory
    sightrun
    module_io_itk
    module_io_vtk
    module_io_dicom
    module_io_matrix
    module_io_activity
    module_io_session
    activity_io_dicom
    activity_io_dicomweb
    activity_viz_negato
    activity_viz_3d
    module_ui_icons
    module_ui_base
)

module_param(module_appXml PARAM_LIST config parameters PARAM_VALUES dicomXplorerBase dicomXplorerAppBase)

sight_generate_profile(dicomxplorer)

=== configs/io/CMakeLists.txt ===
add_subdirectory(dimse)

=== examples/navigation/CMakeLists.txt ===
add_subdirectory(ExVideoTracking)
add_subdirectory(ExStereoARCV)

if(SIGHT_ENABLE_OPENVSLAM)
    add_subdirectory(ExOpenvslam)
endif()

=== debian/changelog ===
sight (21.1.1-3) unstable; urgency=medium

  * Team upload.
  * d/rules: ventilate dh_auto_configure command.
  * d/rules: set SIGHT_ARCH to force CPU baseline.
    The default provided by cmake files is to build with x86-64-v3 which
    would include avx and avx2 support and leading to baseline violations
    otherwise. (Closes: #1023260)

 -- Étienne Mollier <emollier@debian.org>  Tue, 01 Nov 2022 13:04:26 +0100

sight (21.1.1-2) unstable; urgency=medium

  * d/p/: Remove patches applied upstream
    Add several patches to fix lintian warnings
    Add fix to build with gcc12 (Closes: #1016276)

 -- Flavien Bridault <fbridault@ircad.fr>  Sat, 30 Jul 2022 09:51:09 +0200

sight (21.1.1-1) unstable; urgency=medium

  [ Pierre Gruet ]
  * Team upload
  * Conforming to opencv 4.6.0 interface (Closes: #1013903)
  * Checking the package now builds with gcc-12 (Closes: #1013036)
  * Standards-Version: 4.6.1 (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)

  [ Flavien Bridault ]
  * New upstream version
  * d/p/: Remove patches applied upstream
    Add several patches to fix lintian warnings
    Add fix to build with gcc12. Closes: #1013036
  * d/rules: disable samples build
  * Build-Depends: remove libcamp-dev
  * Depends: remove libcamp

 -- Pierre Gruet <pgt@debian.org>  Fri, 15 Jul 2022 00:13:29 +0200

=== debian/control ===
Source: sight
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Flavien Bridault <fbridault@ircad.fr>
Section: science
Priority: optional
Build-Depends: cmake (>=3.19.0),
               dcmtk,
               debhelper-compat (= 13),
               dh-exec,
               dbus-x11,
               libarchive-dev,
               libboost-all-dev,
               libceres-dev,
               libcppunit-dev,
               libexpat1-dev,
               libfftw3-dev,
               libgdcm-dev,
               libglm-dev,
               libinsighttoolkit5-dev,
               libogre-1.12-dev,
               libopencv-dev,
               libopenigtlink-dev,
               libqt5opengl5-dev,
               libqt5x11extras5-dev,
               libvtk9-dev,
               libvtkgdcm-dev,
               libvtk9-qt-dev,
               pandoc,
               qt3d5-dev,
               qtmultimedia5-dev,
               qtquickcontrols2-5-dev,
               qttools5-dev,
               rdfind,
               symlinks,
               xauth,
               xvfb,
               zlib1g-dev,
               zstd
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/med-team/sight
Vcs-Git: https://salsa.debian.org/med-team/sight.git
Homepage: https://git.ircad.fr/Sight/sight
Rules-Requires-Root: no

Package: libsight
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Conflicts: fw4spl
Provides: fw4spl
Replaces: fw4spl
Description: Sight libraries
 The Surgical Image Guidance and
 Healthcare Toolkit aims to ease the creation of
 applications based on medical imaging. It includes
 various features such as 2D and 3D digital image
 processing, visualization, augmented reality and
 medical interaction simulation. It runs on many
 different environments (Windows, Linux, macOS), is
 written in C++, and features rapid interface design
 using XML files.
 .
 Sight was formerly known as FW4SPL. It was renamed
 in 2018, firstly to make its purpose clearer, and
 secondly as part of a major change in design and in
 the governance of the development team.
 .
 This package provides the shared libraries needed to
 run C++ programs that use Sight.

Package: libsight-dev
Architecture: any
Section: libdevel
Depends: libsight (= ${binary:Version}),
         libboost-all-dev,
         zlib1g-dev,
         libexpat1-dev,
         libpng-dev,
         libtiff5-dev,
         libcppunit-dev,
         libhdf5-dev,
         libqt5opengl5-dev,
         libqt5x11extras5-dev,
         qttools5-dev,
         libvtk9-dev,
         libgdcm-dev,
         libinsighttoolkit5-dev,
         libann-dev,
         libvtkgdcm-dev,
         libvtk9-qt-dev,
         libglm-dev,
         libogre-1.12-dev,
         ${shlibs:Depends},
         ${misc:Depends}
Description: Sight header files
 The Surgical Image Guidance and
 Healthcare Toolkit aims to ease the creation of
 applications based on medical imaging. It includes
 various features such as 2D and 3D digital image
 processing, visualization, augmented reality and
 medical interaction simulation. It runs on many
 different environments (Windows, Linux, macOS), is
 written in C++, and features rapid interface design
 using XML files.
 .
 Sight was formerly known as FW4SPL. It was renamed
 in 2018, firstly to make its purpose clearer, and
 secondly as part of a major change in design and in
 the governance of the development team.
 .
 This package contains the development files.

Package: sightviewer
Architecture: any
Depends: libsight (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Conflicts: vrrender
Provides: vrrender
Replaces: vrrender
Description: DICOM viewer
 Medical image viewer featuring negatoscope, multi-planar
 reconstruction, and volume rendering.
 .
 Many image formats are handled such as DICOM, mhd,
 inr.gz, vtk, vti,... Reconstructions can also be imported from 
 DICOM segmentations or VTK supported formats, and visualized
 in mixed rendering with images.
 .
 Tools are provided to measure distances of
 structures in the image and to place landmarks.
 .
 Last, SightViewer can also connect directly to a PACS, and
 then request, download or upload DICOM files.

Package: sightcalibrator
Architecture: any
Depends: libsight (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: Camera calibration software
 User-friendly application to calibrate mono and stereo cameras.
 .
 SightCalibrator can take images, video files, or any supported
 camera device as input. It detects the presence of a checkerboard
 in images. The parameters of the checkboard can be customized.
 Individual images can then be marked to be used in the
 computation of the calibration. Last, the intrinsic and extrinsic
 parameters can be exported in OpenCV format, Yaml or XML.

=== debian/rules ===
#!/usr/bin/make -f

#fix the lintian "hardening" message
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_WITH_INSTALL_RPATH=FALSE \
		-DCMAKE_INSTALL_RPATH="/usr/lib/$(DEB_HOST_MULTIARCH)/sight" \
		-Wno-dev \
		-DSIGHT_BUILD_EXAMPLES=OFF \
		-DSIGHT_BUILD_TESTS=OFF \
		-DGIT_TAG=$(DEB_VERSION_UPSTREAM) \
		-DSIGHT_ARCH=x86-64 \
		-DCMAKE_BUILD_TYPE=Release

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	echo "test disabled"
endif

override_dh_shlibdeps:
	dh_shlibdeps -v -l/usr/lib/$(DEB_HOST_MULTIARCH):/usr/lib/$(DEB_HOST_MULTIARCH)/sight

override_dh_install:
	dh_install
	sed -i -e 's@^me=.*$$@me=/usr/bin@' \
		-e 's@^rootdir=.*$$@rootdir=/usr@' \
		debian/sightviewer/usr/bin/sightviewer

## sight 23.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,8 +15,10 @@
 # Use old policy for Documentation to add cache variables and find VTK documentation dependent packages.
 # (Needed for doxygen..)
 cmake_policy(SET CMP0106 OLD)
-
-if(${CMAKE_VERSION} VERSION_GREATER "3.20.0")
+# Use new policy for CMAKE_MSVC_DEBUG_INFORMATION_FORMAT
+cmake_policy(SET CMP0141 NEW)
+
+if(${CMAKE_VERSION} VERSION_GREATER "3.25.0")
     # Transform the ``DEPFILE`` after running the custom command for Ninja generator.
     cmake_policy(SET CMP0116 OLD)
 endif()
@@ -40,7 +42,7 @@
 
 project(
     sight
-    VERSION 21.1.0
+    VERSION 23.1.0
     DESCRIPTION "Surgical Image Guidance and Healthcare Toolkit"
     HOMEPAGE_URL "https://git.ircad.fr/sight/sight"
 )
@@ -63,6 +65,7 @@
 
 include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/build/flags.cmake)
 include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/build/macros.cmake)
+include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/build/pch.cmake)
 list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/build/linux/modules)
 
 # We find VTK to know its version so we can enable PCL or not
@@ -81,7 +84,7 @@
 set(SIGHT_TESTS_FILTER "" CACHE STRING "Allows to only build/run tests whose path contains the filter string.")
 mark_as_advanced(SIGHT_TESTS_FILTER)
 
-if(UNIX AND (${CMAKE_BUILD_TYPE} STREQUAL "Debug" OR ${CMAKE_BUILD_TYPE} STREQUAL "RelWithDebInfo"))
+if(UNIX)
     option(SIGHT_ENABLE_GDB
            "Test scripts will attach GDB, allowing to generate core file and print backtrace in case of crash." OFF
     )
@@ -94,28 +97,20 @@
 
 # Use clang-tidy linter
 option(SIGHT_ENABLE_CLANG_TIDY "Enable Clang Tidy checks" OFF)
-mark_as_advanced(SIGHT_TESTS_FILTER)
+mark_as_advanced(SIGHT_ENABLE_CLANG_TIDY)
 
 if(SIGHT_ENABLE_CLANG_TIDY)
     # cmake-lint: disable=C0301
-    find_program(CLANG_TIDY NAMES "clang-tidy" "clang-tidy-10" "clang-tidy-11" "clang-tidy-12" "clang-tidy-13" REQUIRED)
-    set(CMAKE_CXX_CLANG_TIDY
-        ${CLANG_TIDY};--header-filter=.*;--checks=*,-llvm-header-guard,-llvm-include-order,-llvmlibc-*,-fuchsia-*,-altera-struct-pack-align,-cppcoreguidelines-macro-usage,-bugprone-macro-parentheses;--use-color;--export-fixes=.clang-tidy-fixes.yaml
-    )
+    find_program(CLANG_TIDY NAMES "clang-tidy" "clang-tidy-14" REQUIRED)
+    set(CMAKE_CXX_CLANG_TIDY ${CLANG_TIDY};--use-color;--export-fixes=.clang-tidy-fixes.yaml)
+
+    # Also generate compile_commands.json which is useful when launching clang-tidy by "hand"
+    set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
 endif()
 
 # QML_IMPORT_PATH allows qtCreator to find the qml modules created in our modules
 set(QML_IMPORT_PATH "" CACHE STRING "Path of the Qml modules." FORCE)
 mark_as_advanced(QML_IMPORT_PATH)
-
-include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/build/PrecompiledHeader.cmake)
-
-if(MSVC)
-    if(NOT DEFINED CMAKE_PCH_COMPILER_TARGETS)
-        # this will be executed in just before makefile generation
-        variable_watch(CMAKE_BACKWARDS_COMPATIBILITY pch_msvc_hook)
-    endif()
-endif()
 
 if(CMAKE_CONFIGURATION_TYPES)
     set(CMAKE_CONFIGURATION_TYPES ${CMAKE_BUILD_TYPE} CACHE STRING "List of supported configurations." FORCE)
@@ -133,20 +128,25 @@
 if(SIGHT_ENABLE_ENCRYPTED_LOG)
     add_compile_definitions(SIGHT_ENABLE_ENCRYPTED_LOG)
 endif()
-add_compile_definitions(SIGHT_DEFAULT_PASSWORD="${SIGHT_DEFAULT_PASSWORD}")
+if(SIGHT_DEFAULT_PASSWORD)
+    add_compile_definitions(SIGHT_DEFAULT_PASSWORD="${SIGHT_DEFAULT_PASSWORD}")
+endif()
 
 # Use solution folders.
 set_property(GLOBAL PROPERTY USE_FOLDERS ON)
 set_property(GLOBAL PROPERTY AUTOGEN_TARGETS_FOLDER automoc)
 
-# Make openvslam optional
-option(SIGHT_ENABLE_OPENVSLAM "Enable OpenVSLAM" OFF)
-
+# Make openvslam optional on Linux
+if(NOT MSVC)
+    option(SIGHT_ENABLE_OPENVSLAM "Enable OpenVSLAM" OFF)
+endif()
 # Make Realsense optional
 option(SIGHT_ENABLE_REALSENSE "Enable RealSense" OFF)
 
 # Make samples/tutorials build optional
 option(SIGHT_BUILD_EXAMPLES "Build examples and tutorials" ON)
+
+option(SIGHT_BUILD_MANPAGES "Generate man pages for applications" OFF)
 
 ########################################################################################################################
 # Warn user of install dir isn't empty
@@ -237,6 +237,7 @@
     add_subdirectory(tutorials)
     add_subdirectory(examples)
 endif()
+add_subdirectory(3rd-party)
 
 ########################################################################################################################
 # Export and install targets
@@ -256,6 +257,15 @@
 configure_file(
     ${CMAKE_CURRENT_SOURCE_DIR}/cmake/install/linux/safe-xvfb-run ${CMAKE_CURRENT_BINARY_DIR}/bin/safe-xvfb-run
     COPYONLY
+)
+
+configure_file(
+    ${CMAKE_CURRENT_SOURCE_DIR}/cmake/install/linux/exec_gui_tests.sh ${CMAKE_CURRENT_BINARY_DIR}/bin/exec_gui_tests.sh
+    COPYONLY
+)
+configure_file(
+    ${CMAKE_CURRENT_SOURCE_DIR}/cmake/install/windows/exec_gui_tests.bat
+    ${CMAKE_CURRENT_BINARY_DIR}/bin/exec_gui_tests.bat COPYONLY
 )
 
 # Install the sightConfig.cmake and sightConfigVersion.cmake
@@ -279,5 +289,3 @@
           "${FWCMAKE_RESOURCE_PATH}/build/cppunit_main.cpp"
           "${CMAKE_SOURCE_DIR}/cmake/build/config.hpp.in"
           "${CMAKE_SOURCE_DIR}/cmake/build/plugin_config.cmake"
-          "${CMAKE_SOURCE_DIR}/cmake/build/plugin_config_command.cmake"
-          "${CMAKE_SOURCE_DIR}/cmake/build/profile_config.cmake"

=== apps/CMakeLists.txt ===
add_subdirectory(SightCalibrator)
add_subdirectory(dicomxplorer)
add_subdirectory(SightViewer)
add_subdirectory(ArchiveExtractor)

=== utils/CMakeLists.txt ===
add_subdirectory(DicomAnonymizer)
add_subdirectory(sightrun)
add_subdirectory(arucoMarker)
add_subdirectory(NetworkProxy)
add_subdirectory(sightlog)

=== 3rd-party/minizip/CMakeLists.txt ===
file(GLOB MINIZIP_SOURCES *.c *.h)
add_library(minizip STATIC ${MINIZIP_SOURCES})
target_compile_options(minizip PRIVATE "$<$<CXX_COMPILER_ID:GNU,Clang>:-w>$<$<CXX_COMPILER_ID:MSVC>:/w>")

include(CheckIncludeFile)
include(CheckTypeSize)
include(CheckFunctionExists)

# Check for system includes
check_include_file(stdint.h HAVE_STDINT_H)
if(HAVE_STDINT_H)
    target_compile_definitions(minizip PRIVATE "-DHAVE_STDINT_H")
endif()

check_include_file(inttypes.h HAVE_INTTYPES_H)
if(HAVE_INTTYPES_H)
    target_compile_definitions(minizip PRIVATE "-DHAVE_INTTYPES_H")
endif()

# Check for large file support
check_type_size(off64_t OFF64_T)
if(HAVE_OFF64_T)
    target_compile_definitions(minizip PRIVATE "-D__USE_LARGEFILE64")
    target_compile_definitions(minizip PRIVATE "-D_LARGEFILE64_SOURCE")
endif()

# Check for fseeko support
check_function_exists(fseeko HAVE_FSEEKO)
if(NOT HAVE_FSEEKO)
    target_compile_definitions(minizip PRIVATE "-DNO_FSEEKO")
endif()

# ZLIB
find_package(ZLIB QUIET REQUIRED)
target_link_libraries(minizip PRIVATE ZLIB::ZLIB)
target_compile_definitions(minizip PRIVATE "-DHAVE_ZLIB")
target_compile_definitions(minizip PRIVATE "-DZLIB_COMPAT")

# ZSTD
find_package(PkgConfig QUIET)
if(PKGCONFIG_FOUND)
    pkg_check_modules(ZSTD libzstd)
endif()
if(ZSTD_FOUND)
    target_include_directories(minizip SYSTEM PRIVATE ${ZSTD_INCLUDE_DIRS})
    target_link_libraries(minizip PRIVATE ${ZSTD_LIBRARIES})
else()
    find_package(zstd CONFIG REQUIRED)
    target_link_libraries(minizip PRIVATE zstd::libzstd_shared)
endif()
target_compile_definitions(minizip PRIVATE "-DHAVE_ZSTD")

# OpenSSL
find_package(OpenSSL QUIET REQUIRED COMPONENTS Crypto)
target_link_libraries(minizip PRIVATE OpenSSL::Crypto)

# Windows specific
if(WIN32)
    target_compile_definitions(minizip PRIVATE "-D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE")
endif()

# Unix specific
if(UNIX)
    # ICONV
    find_package(Iconv QUIET REQUIRED)
    target_include_directories(minizip SYSTEM PRIVATE ${Iconv_INCLUDE_DIRS})
    target_link_libraries(minizip PRIVATE ${Iconv_LIBRARIES})
    target_compile_definitions(minizip PRIVATE "-DHAVE_ICONV")
endif()

# Setup predefined macros
target_compile_definitions(minizip PRIVATE "-DMZ_ZIP_SIGNING")

# Include WinZIP AES encryption
target_compile_definitions(minizip PRIVATE "-DHAVE_WZAES")

=== apps/ArchiveExtractor/CMakeLists.txt ===
sight_add_target(ArchiveExtractor TYPE APP)

add_dependencies(
    ArchiveExtractor
    sightrun
    module_appXml
    module_ui_base
    module_ui_qt
    module_ui_flaticons
    module_io_zip
)

# Allow dark theme via module_ui_qt
module_param(
    module_ui_qt PARAM_LIST resource stylesheet PARAM_VALUES sight::module::ui::qt/flatdark.rcc
                                                             sight::module::ui::qt/flatdark.qss
)

# Main application's configuration to launch
module_param(module_appXml PARAM_LIST config PARAM_VALUES ArchiveExtractor_AppCfg)

sight_generate_profile(ArchiveExtractor)

=== apps/SightCalibrator/CMakeLists.txt ===
--- 
+++ 
@@ -39,3 +39,7 @@
 module_param(module_appXml PARAM_LIST config parameters PARAM_VALUES SightCalibrator_AppCfg SightCalibrator_AppCfgParam)
 
 sight_generate_profile(SightCalibrator)
+
+if(SIGHT_BUILD_TESTS)
+    add_subdirectory(test)
+endif()

=== apps/SightViewer/CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,6 @@
     sightrun
     module_appXml
     module_ui_base
-    module_viz_scene3d
     module_ui_qt
     module_viz_scene3dQt
     module_service
@@ -14,12 +13,11 @@
     module_ui_base
     module_ui_viz
     module_ui_flaticons
+    module_io_itk
     module_io_vtk
     module_io_dicom
     module_io_session
-    module_viz_scene2d
-    module_data
-    module_filter_image
+    config_viz_scene2d
     config_viz_scene3d
     config_io_dimse
 )
@@ -34,3 +32,7 @@
 module_param(module_appXml PARAM_LIST config PARAM_VALUES SightViewer_AppCfg)
 
 sight_generate_profile(SightViewer)
+
+if(SIGHT_BUILD_TESTS)
+    add_subdirectory(test)
+endif(SIGHT_BUILD_TESTS)

=== configs/io/CMakeLists.txt ===
add_subdirectory(dimse)
add_subdirectory(video)

=== configs/ui/CMakeLists.txt ===
add_subdirectory(activity)
add_subdirectory(dataManager)

=== examples/filter/CMakeLists.txt ===
add_subdirectory(ExDetectCamMotion)
add_subdirectory(ExImageSubstraction)
add_subdirectory(ExRegistration)
if(SIGHT_ENABLE_REALSENSE)
    add_subdirectory(ExRGBDImageMasking)
endif()
add_subdirectory(ExDicomSegmentation)

=== examples/geometry/CMakeLists.txt ===
add_subdirectory(ExRGBDManualAR)
add_subdirectory(ExSolvePnP)

=== examples/io/CMakeLists.txt ===
add_subdirectory(ExVideoRecorder)
add_subdirectory(ExFrameByFrame)
add_subdirectory(ExIgtl)
if(SIGHT_ENABLE_REALSENSE)
    add_subdirectory(ExRealSense)
endif()

=== debian/changelog ===
sight (23.1.0-2build5) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:42:13 +1100

sight (23.1.0-2build4) noble; urgency=medium

  * No-change rebuild against libcurl4t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 07:02:45 +0000

sight (23.1.0-2build3) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 07:05:26 +0000

sight (23.1.0-2build2) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 21:22:07 +0000

sight (23.1.0-2build1) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 08:13:55 +0000

sight (23.1.0-2) unstable; urgency=medium

  * d/p/gcc13.patch: Update patch (Closes: #1059140)
  * Updated minizip copyright entry

 -- Flavien BRIDAULT <flavien.bridault@ircad.fr>  Thu, 21 Dec 2023 14:22:47 +0100

sight (23.1.0-1) unstable; urgency=medium

  [ Flavien BRIDAULT ]
  * New upstream version
  * d/p/: Remove patches applied upstream
    Add patch to build with gcc13
    Closes: #1037858, #1039529

  [ Andreas Tille ]
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Remove trailing whitespace in debian/control (routine-update)

 -- Flavien BRIDAULT <fbridault@ircad.fr>  Mon, 06 Nov 2023 13:04:23 +0100

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: sight
-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Flavien Bridault <fbridault@ircad.fr>
 Section: science
 Priority: optional
@@ -36,7 +37,7 @@
                xvfb,
                zlib1g-dev,
                zstd
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/sight
 Vcs-Git: https://salsa.debian.org/med-team/sight.git
 Homepage: https://git.ircad.fr/Sight/sight
@@ -47,9 +48,7 @@
 Section: libs
 Depends: ${shlibs:Depends},
          ${misc:Depends}
-Conflicts: fw4spl
 Provides: fw4spl
-Replaces: fw4spl
 Description: Sight libraries
  The Surgical Image Guidance and
  Healthcare Toolkit aims to ease the creation of
@@ -77,7 +76,7 @@
          zlib1g-dev,
          libexpat1-dev,
          libpng-dev,
-         libtiff5-dev,
+         libtiff-dev,
          libcppunit-dev,
          libhdf5-dev,
          libqt5opengl5-dev,
@@ -124,7 +123,7 @@
  reconstruction, and volume rendering.
  .
  Many image formats are handled such as DICOM, mhd,
- inr.gz, vtk, vti,... Reconstructions can also be imported from 
+ inr.gz, vtk, vti,... Reconstructions can also be imported from
  DICOM segmentations or VTK supported formats, and visualized
  in mixed rendering with images.
  .

=== debian/rules ===
--- 
+++ 
@@ -25,6 +25,7 @@
 		-DSIGHT_BUILD_TESTS=OFF \
 		-DGIT_TAG=$(DEB_VERSION_UPSTREAM) \
 		-DSIGHT_ARCH=x86-64 \
+		-DSIGHT_BUILD_MANPAGES=ON \
 		-DCMAKE_BUILD_TYPE=Release
 
 override_dh_auto_test:

## sight 24.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,6 +17,8 @@
 cmake_policy(SET CMP0106 OLD)
 # Use new policy for CMAKE_MSVC_DEBUG_INFORMATION_FORMAT
 cmake_policy(SET CMP0141 NEW)
+# Use old policy for now because of openCV
+cmake_policy(SET CMP0146 OLD)
 
 if(${CMAKE_VERSION} VERSION_GREATER "3.25.0")
     # Transform the ``DEPFILE`` after running the custom command for Ninja generator.
@@ -42,7 +44,7 @@
 
 project(
     sight
-    VERSION 23.1.0
+    VERSION 24.0.0
     DESCRIPTION "Surgical Image Guidance and Healthcare Toolkit"
     HOMEPAGE_URL "https://git.ircad.fr/sight/sight"
 )
@@ -65,7 +67,6 @@
 
 include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/build/flags.cmake)
 include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/build/macros.cmake)
-include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/build/pch.cmake)
 list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/build/linux/modules)
 
 # We find VTK to know its version so we can enable PCL or not
@@ -164,7 +165,6 @@
 ########################################################################################################################
 # External libraries management
 ########################################################################################################################
-
 set(FWCMAKE_RESOURCE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/)
 
 # Append our 'FindPackages.cmake' to CMAKE_MODULE_PATH
@@ -206,7 +206,6 @@
 ########################################################################################################################
 # Default paths settings for libraries, modules and resources
 ########################################################################################################################
-
 set(FW_INSTALL_PATH_SUFFIX "${PROJECT_NAME}")
 set(SIGHT_MODULE_RC_PREFIX "${CMAKE_INSTALL_DATADIR}/${FW_INSTALL_PATH_SUFFIX}")
 if(WIN32)
@@ -226,6 +225,8 @@
     set(SIGHT_VCPKG_ROOT_DIR "${_VCPKG_INSTALLED_DIR}/${VCPKG_TARGET_TRIPLET}")
     set(EXCLUDE_PATTERN ".*/debug/.*")
 endif()
+
+sight_configure_pch()
 
 add_subdirectory(libs)
 add_subdirectory(modules)
@@ -287,5 +288,4 @@
     FILES "${CMAKE_SOURCE_DIR}/cmake/build/configure_file.cmake"
           "${CMAKE_SOURCE_DIR}/cmake/build/flags.cmake"
           "${FWCMAKE_RESOURCE_PATH}/build/cppunit_main.cpp"
-          "${CMAKE_SOURCE_DIR}/cmake/build/config.hpp.in"
-          "${CMAKE_SOURCE_DIR}/cmake/build/plugin_config.cmake"
+          "${FWCMAKE_RESOURCE_PATH}/build/pch.cpp"

=== 3rd-party/CMakeLists.txt ===
add_subdirectory(minizip)

=== apps/CMakeLists.txt ===
add_subdirectory(sight_calibrator)
add_subdirectory(dicomxplorer)
add_subdirectory(sight_viewer)
add_subdirectory(archive_extractor)

=== tutorials/CMakeLists.txt ===
add_subdirectory(xml)
add_subdirectory(qml)

=== utils/CMakeLists.txt ===
add_subdirectory(dicom_anonymizer)
add_subdirectory(sightrun)
add_subdirectory(aruco_marker)
add_subdirectory(network_proxy)
add_subdirectory(sightlog)

=== apps/dicomxplorer/CMakeLists.txt ===
sight_add_target(dicomxplorer TYPE APP)

add_dependencies(
    dicomxplorer
    module_service
    data
    module_ui
    module_ui_qt
    module_activity
    module_app
    module_memory
    sightrun
    module_io_itk
    module_io_vtk
    module_io_dicom
    module_io_matrix
    module_io_activity
    module_io_session
    activity_io_dicom
    activity_io_dicomweb
    activity_viz_negato
    activity_viz_3d
    module_ui_icons
    module_ui
)

module_param(module_app PARAM_LIST config parameters PARAM_VALUES dicomXplorerBase dicomXplorerAppBase)

module_param(
    module_ui_qt PARAM_LIST resource stylesheet PARAM_VALUES sight::module::ui::qt/flatdark.rcc
                                                             sight::module::ui::qt/flatdark.qss
)

=== apps/sight_calibrator/CMakeLists.txt ===
sight_add_target(sight_calibrator TYPE APP)

add_dependencies(
    sight_calibrator
    sightrun
    module_app
    module_ui
    module_ui_qt
    module_service
    module_sync
    data
    module_ui
    module_ui_icons
    module_ui_icons
    module_io_vision
    module_io_video
    module_io_activity
    module_io_igtl
    module_io_session
    module_activity
    activity_navigation_calibration
    module_data
    module_memory
    module_geometry_vision
    module_geometry
    module_navigation_calibration
)

if(SIGHT_ENABLE_REALSENSE)
    add_dependencies(sight_calibrator module_io_realsense)
endif()

# Allow dark theme via module_ui_qt
module_param(
    module_ui_qt PARAM_LIST resource stylesheet PARAM_VALUES sight::module::ui::qt/flatdark.rcc
                                                             sight::module::ui::qt/flatdark.qss
)
# Main application's configuration to launch
module_param(module_app PARAM_LIST config parameters PARAM_VALUES SightCalibrator_AppCfg SightCalibrator_AppCfgParam)

if(SIGHT_BUILD_TESTS)
    add_subdirectory(test/uit)
endif()

=== apps/sight_viewer/CMakeLists.txt ===
sight_add_target(sight_viewer TYPE APP)

add_dependencies(
    sight_viewer
    sightrun
    module_app
    module_ui
    module_ui_qt
    module_viz_scene3d_qt
    module_service
    data
    viz_scene2d
    module_ui
    module_ui_viz
    module_ui_icons
    module_io_itk
    module_io_vtk
    module_io_dicom
    module_io_session
    config_viz_scene2d
    config_viz_scene3d
    config_io_dimse
)

module_param(
    module_ui_qt PARAM_LIST resource stylesheet touch_friendly PARAM_VALUES sight::module::ui::qt/noctura.rcc
                                                                            sight::module::ui::qt/noctura.qss true
)

# Main application's configuration to launch
module_param(module_app PARAM_LIST config PARAM_VALUES SightViewer_AppCfg)

if(SIGHT_BUILD_TESTS)
    add_subdirectory(test/uit)
endif(SIGHT_BUILD_TESTS)

=== examples/filter/CMakeLists.txt ===
add_subdirectory(ex_detect_cam_motion)
add_subdirectory(ex_image_substraction)
add_subdirectory(ex_registration)
if(SIGHT_ENABLE_REALSENSE)
    add_subdirectory(ex_rgbd_image_masking)
endif()
add_subdirectory(ex_dicom_segmentation)

=== examples/navigation/CMakeLists.txt ===
add_subdirectory(ex_video_tracking)
add_subdirectory(ex_stereo_ar)

if(SIGHT_ENABLE_OPENVSLAM)
    add_subdirectory(ex_openvslam)
endif()

=== examples/ui/CMakeLists.txt ===
add_subdirectory(ex_notifications)
add_subdirectory(ex_parameters)
add_subdirectory(ex_progress_bar)
add_subdirectory(ex_collapsible_section)

=== libs/navigation/CMakeLists.txt ===
if(SIGHT_ENABLE_OPENVSLAM)
    add_subdirectory(openvslam)
endif()

=== debian/changelog ===
sight (24.1.0-2build1) plucky; urgency=medium

  * No-change rebuild for opencv 4.10.0.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Wed, 19 Feb 2025 08:48:18 +0000

sight (24.1.0-2) unstable; urgency=medium

  * Team upload.
  * [1d3de11] Add missing build-dep packages.  Closes: #1094050.
  * [f5fe527] Fix usage of itkTypeMacro().  Closes: #1094894.

 -- Steve M. Robbins <smr@debian.org>  Thu, 13 Feb 2025 22:24:09 -0600

sight (24.1.0-1) unstable; urgency=medium

  [ Flavien BRIDAULT ]
  * New upstream version
  * d/p/: Added patch for dcmtk 3.6.8
    Add patch to build with gcc14
    Closes: #1075792, #1075508
  * Depends: add fonts-roboto and do not install those from source

  [ Étienne Mollier ]
  * d/copyright: update copyright years.
  * d/control: declare compliance to standards version 4.7.0.

 -- Flavien Bridault <fbridault@ircad.fr>  Wed, 21 Aug 2024 13:56:45 +0200

sight (23.1.0-3) unstable; urgency=medium

  * Team upload.
  * [c1dc603] Fix FTBFS against VTK9.3. (Closes: #1073822)
  * [afc423e] Update CI-file

 -- Anton Gladky <gladk@debian.org>  Fri, 21 Jun 2024 14:47:57 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: sight
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Flavien Bridault <fbridault@ircad.fr>
 Section: science
 Priority: optional
-Build-Depends: cmake (>=3.19.0),
+Build-Depends: binutils-gold,
+               cmake (>=3.19.0),
                dcmtk,
                debhelper-compat (= 13),
                dh-exec,
@@ -15,7 +15,7 @@
                libcppunit-dev,
                libexpat1-dev,
                libfftw3-dev,
-               libgdcm-dev,
+               libgdcm-dev, libgdcm-tools,
                libglm-dev,
                libinsighttoolkit5-dev,
                libogre-1.12-dev,
@@ -23,11 +23,13 @@
                libopenigtlink-dev,
                libqt5opengl5-dev,
                libqt5x11extras5-dev,
+               libqt5svg5-dev,
                libvtk9-dev,
                libvtkgdcm-dev,
                libvtk9-qt-dev,
                pandoc,
                qt3d5-dev,
+               qtdeclarative5-dev,
                qtmultimedia5-dev,
                qtquickcontrols2-5-dev,
                qttools5-dev,
@@ -37,7 +39,7 @@
                xvfb,
                zlib1g-dev,
                zstd
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/med-team/sight
 Vcs-Git: https://salsa.debian.org/med-team/sight.git
 Homepage: https://git.ircad.fr/Sight/sight
@@ -47,7 +49,8 @@
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends},
-         ${misc:Depends}
+         ${misc:Depends},
+         fonts-roboto
 Provides: fw4spl
 Description: Sight libraries
  The Surgical Image Guidance and
@@ -81,6 +84,7 @@
          libhdf5-dev,
          libqt5opengl5-dev,
          libqt5x11extras5-dev,
+         libqt5svg5-dev,
          qttools5-dev,
          libvtk9-dev,
          libgdcm-dev,
